import Gio from 'gi://Gio';
import GLib from 'gi://GLib';
import GObject from 'gi://GObject';

//Gio._promisify(Gio.DBusProxy, 'call');
Gio._promisify(Gio.DBusProxy, 'new_for_bus');

const DisplayConfigInterface = 
    '<node>\
        <interface name="org.gnome.Mutter.DisplayConfig">\
            <property name="ApplyMonitorsConfigAllowed" type="b" access="read" />\
            <signal name="MonitorsChanged" />\
            <method name="GetCurrentState">\
                <arg name="serial" direction="out" type="u" />\
                <arg name="monitors" direction="out" type="a((ssss)a(siiddada{sv})a{sv})" />\
                <arg name="logical_monitors" direction="out" type="a(iiduba(ssss)a{sv})" />\
                <arg name="properties" direction="out" type="a{sv}" />\
            </method>\
            <method name="ApplyMonitorsConfig">\
                <arg name="serial" direction="in" type="u" />\
                <arg name="method" direction="in" type="u" />\
                <arg name="logical_monitors" direction="in" type="a(iiduba(ssa{sv}))" />\
                <arg name="properties" direction="in" type="a{sv}" />\
            </method>\
        </interface>\
    </node>';

const proxy = await Gio.DBusProxy.new_for_bus(
    Gio.BusType.SESSION,
    Gio.DBusProxyFlags.NONE,
    null,
    'org.gnome.Mutter.DisplayConfig',
    '/org/gnome/Mutter/DisplayConfig',
    'org.gnome.Mutter.DisplayConfig',
    null);

Gio._promisify(proxy, 'call');

const reply = await proxy.call(
    'GetCurrentState',
    null,
    Gio.DBusCallFlags.NONE,
    -1,
    null
);

log(reply);

const b = GLib.Variant.new_boolean(true);
log(b);
log(JSON.stringify(b));

// const DisplayConfigProxy = Gio.DBusProxy.makeProxyWrapper(DisplayConfigInterface);
// log(DisplayConfigProxy);

// const proxy = new DisplayConfigProxy(
//     Gio.DBus.session,
//     'org.gnome.Mutter.DisplayConfig',
//     '/org/gnome/Mutter/DisplayConfig');
 
// log(proxy.GetCurrentStateSync());

// const reply = Gio.DBus.session.call_sync(
//     'org.gnome.Mutter.DisplayConfig',
//     '/org/gnome/Mutter/DisplayConfig',
//     'org.gnome.Mutter.DisplayConfig',
//     'GetCurrentState',
//     null,
//     null,
//     Gio.DBusCallFlags.NONE,
//     -1,
//     null);

// log(reply.recursiveUnpack());